package diffusion;

import java.io.File;
import java.io.FileWriter;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;


public class SaveData{
	
	ArrayList<Double[]> list;
	private Double[] data; 
	String name;
	String fileName;
	
	SaveData(String name){
		list=new ArrayList<Double[]>();
		this.name=name;
	}
	
	public void addData(double[] data){
		this.data=new Double[data.length];
		for(int i=0;i<data.length;i++){
			this.data[i]=data[i];
		}	
		list.add(this.data);
	}
	
	public ArrayList<Double[]> getList(){
		return list;
	}
	
	public void SetFileName(double DGAP, double k0p,double k1p,double k2p,double k2n,double k3n, double r_GAP, double c_sat,double r_noise){
		fileName="DGAP_"+DGAP+"_k0p_"+k0p+"_k1p_"+k1p+"_k2p_"+k2p+"_k2n_"+k2n+"_k3n_"+k3n+"_r_GAP_"+r_GAP+"_c-sat_"+c_sat+"_r-noise_"+r_noise;
	}
	
	public String GetFileName(){
		return fileName;
	}
	
	public void WriteToFile(){
		try{
			  File file=new File("D:/"+GetFileName()+"/"+name+".txt");
			  if(file.exists())
				  file.delete();
				    System.out.println(name+" directory created!");
				    file.getParentFile().mkdirs();
		      
				    FileWriter fw=new FileWriter(file);
			    	BufferedWriter bw = new BufferedWriter(fw);
			    	for(int i=0;i<list.size();i++){
			    		for(int j=0;j<list.get(i).length;j++){
		    			  bw.write(Math.round(list.get(i)[j]*Math.pow(10,7))/Math.pow(10,7)+"\t");
		    		  }
			    		bw.write("\n");
			    	}
			    	bw.close();
			}catch (IOException e) {
				e.printStackTrace();
			}
	}
	
	/*public void setParameter(String param, double val){
	    if(param.equalsIgnoreCase("DGTP")){
	    	DGTP = val; 
	    }else if(param.equalsIgnoreCase("DGDP")){
	    	DGDP=val;
	    }else if(param.equalsIgnoreCase("DGAP")){
	    	DGAP=val;
	    }else if(param.equalsIgnoreCase("GAPhydro")){
	    	GAPhydro=val;
	    }else if(param.equalsIgnoreCase("k0")){
	    	k0=val;
	    }else if(param.equalsIgnoreCase("k1")){
	    	k1=val;
	    }else if(param.equalsIgnoreCase("k2")){
	    	k2=val;
	    }else if(param.equalsIgnoreCase("k3")){
	    	k3=val;
	    }else if(param.equalsIgnoreCase("k")){
	    	k=val;
	    }else if(param.equalsIgnoreCase("c1")){
	    	c1=val;
	    }else if(param.equalsIgnoreCase("c2")){
	    	c2=val;
	    }else if(param.equalsIgnoreCase("length")){
	    	length=val;
	    }else if(param.equalsIgnoreCase("radius")){
	    	radius=val;
	    }else if(param.equalsIgnoreCase("dt")){
	    	dt=val;
	    }else if(param.equalsIgnoreCase("nx")){
	    	nx=(int) val;
	    }else if(param.equalsIgnoreCase("ny")){
	    	ny=(int) val;
	    }else if(param.equalsIgnoreCase("nz")){
	    	nz=(int) val;
	    }else if(param.equalsIgnoreCase("Smin")){
	    	Smin=val;
	    }else if(param.equalsIgnoreCase("Smax")){
	    	Smax=val;
	    }else if(param.equalsIgnoreCase("T")){
	    	T=val;
	    }else if(param.equalsIgnoreCase("visualizationTime")){
	    	visualizationTime=val;
	    }else if(param.equalsIgnoreCase("lx")){
	    	lx=(double) val;
	    }else if(param.equalsIgnoreCase("ly")){
	    	ly=(double) val;
	    }else if(param.equalsIgnoreCase("lz")){
	    	lz=(double) val;
	    }
	}*/
}
