/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package custom.io;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

/**
 *
 * @author danhurwitz
 */
public class ioSerial {
  
  public static <T> void write(T obj, File f){
      try{
      FileOutputStream fileOut = new FileOutputStream(f);
      ObjectOutputStream out = new ObjectOutputStream(fileOut);

      out.writeObject(obj);

      out.close();
      fileOut.close();
    } catch (IOException e){
      System.out.println("IOException: Error writing " + obj.getClass().getName() +  " object to file " + f.getAbsolutePath());
    }// end catch 
  } // end write 
  
  public static <T> T read(File f) {
    
    T obj = null; 
    try{
      FileInputStream fileIn = new FileInputStream(f);
      ObjectInputStream in = new ObjectInputStream(fileIn);
      obj = (T) in.readObject();
    }catch(ClassNotFoundException c ){
      System.out.println("ClassNotFoundException: Could not find class.");
    }catch(IOException e){
      System.out.println("IOException: Could not open " + f.getAbsolutePath() + " for reading.");
    } // end catch 
    
    return obj; 
    
  }
  
  
  
}// end class 
